
------------------------------------------------------------------------------------
-- Name : nUI_Plugin_TempMovers                                          
-- Copyright : Tina Kirby AKA Xrystal (C) 2009/2010 All Rights Reserved      
-- Contact : xrystal@swangen.co.uk                                           
-- Download Sites :                                                          
-- Version : 1.01.00 - New
-- Version : 1.02.00 - Added fake player frame functionality on target change
-- Version : 1.03.00 - also used fake player frame stuff on entering world
-- Version : 1.04.00 - Use Paladin and Warlock OnLoad and Update routines when initialising 
-- Version : 1.05.00 - Use Druid UpdateShown routine when initialising
-- Version : 1.06.00 - Hide Druid Eclipse Bar so as not to call OnShow too soon
-- Version : 1.07.00 - Make sure Druid Eclipse Bar is allowed to be moved
------------------------------------------------------------------------------------

--[[ Use Addon Wide Data Table ]]--
local addonName,addonData = ...

local PTM_Frame = CreateFrame("Frame","nUI_PowerBarFrame",UIParent);
PTM_Frame.unit = "player";
PTM_Frame:SetParent(UIParent);
PTM_Frame:SetPoint( "TOP", nUI_TopBars, "BOTTOM", 0, 12 );

-- Brewmaster Stagger and Windwalker Harmony Bars for Monks
-- Separated bars into their own management functions
local function PTM_MonkHBInit()
    PlayerFrameBottomManagedFramesContainer:SetParent(PTM_Frame)
	MonkHarmonyBarFrame:SetParent(PlayerFrameBottomManagedFramesContainer);
    nUI_Movers:lockFrame( MonkHarmonyBarFrame, false, "nUI_MonkHarmonyBarFrame" );
end
local function PTM_MonkSBInit()
    PlayerFrameBottomManagedFramesContainer:SetParent(PTM_Frame)
	MonkStaggerBar:SetParent(PlayerFrameBottomManagedFramesContainer);
    nUI_Movers:lockFrame( MonkStaggerBar, false, "nUI_MonkStaggerBar" );
end

-- Warlock Shards
local function PTM_WarlockPBInit()
    PlayerFrameBottomManagedFramesContainer:SetParent(PTM_Frame)
    WarlockPowerFrame:SetParent(PlayerFrameBottomManagedFramesContainer)        
    nUI_Movers:lockFrame( WarlockPowerFrame, false, "nUI_WarlockPowerFrame" );
    -- Power Type 124 : Chaos 
end

-- Paladin Holy Power Bar
local function PTM_PaladinPBInit()
    PlayerFrameBottomManagedFramesContainer:SetParent(PTM_Frame)
    PaladinPowerBarFrame:SetParent(PlayerFrameBottomManagedFramesContainer)        
    nUI_Movers:lockFrame( PaladinPowerBarFrame, false, "nUI_PaladinPowerBarFrame" );
end

-- Mage Arcane Bar
local function PTM_MagePBInit()
    PlayerFrameBottomManagedFramesContainer:SetParent(PTM_Frame)
    MageArcaneChargesFrame:SetParent(PlayerFrameBottomManagedFramesContainer)        
    nUI_Movers:lockFrame( MageArcaneChargesFrame, true, "nUI_MageArcaneChargesFrame" ); 		
    -- Power Type 64 to investigate
end

-- Shaman Totem Bar
-- Shaman Alternate Mana Bar
local function PTM_ShamanTotemsInit()
    PlayerFrameBottomManagedFramesContainer:SetParent(PTM_Frame)
    TotemFrame:SetParent(PlayerFrameBottomManagedFramesContainer)        
    nUI_Movers:lockFrame( TotemFrame, true, "nUI_ShamanTotemFrame" ); 		
    PlayerFrameAlternateManaBar:SetParent(PlayerFrameBottomManagedFramesContainer)        
    nUI_Movers:lockFrame( PlayerFrameAlternateManaBar, true, "nUI_ShamanAlternateManaBar" ); 		
end

-- Moonkin Alternate Mana Bar
-- Cat Combo Point Bar
-- Restoration Totem Frame
local function PTM_DruidPBInit()
    PlayerFrameBottomManagedFramesContainer:SetParent(PTM_Frame)
    PlayerFrameAlternateManaBar:SetParent(PlayerFrameBottomManagedFramesContainer)        
    nUI_Movers:lockFrame( PlayerFrameAlternateManaBar, true, "nUI_DruidAlternateManaBar" ); 
    -- Renamed in 10.1
    --ComboPointDruidPlayerFrame:SetParent(PlayerFrameBottomManagedFramesContainer)
    --nUI_Movers:lockFrame( ComboPointDruidPlayerFrame, true, "nUI_DruidComboPointFrame" ); 		
    DruidComboPointBarFrame:SetParent(PlayerFrameBottomManagedFramesContainer)
    nUI_Movers:lockFrame( DruidComboPointBarFrame, true, "nUI_DruidComboPointFrame" ); 		
    
    TotemFrame:SetParent(PlayerFrameBottomManagedFramesContainer)        
    nUI_Movers:lockFrame( TotemFrame, true, "nUI_DruidTotemFrame" ); 		
    -- Power Type 64 to investigate
end

-- Combo point from player frame
-- Note there is also a ComboFrame linked to the target frame and nUI uses that on the hud display - is there a difference ? 
local function PTM_RogueComboInit()
    PlayerFrameBottomManagedFramesContainer:SetParent(PTM_Frame)
    -- Changed in 10.1
    --ComboPointPlayerFrame:SetParent(PlayerFrameBottomManagedFramesContainer)
    --nUI_Movers:lockFrame( ComboPointPlayerFrame, true, "nUI_RogueComboPointFrame" ); 		
    RogueComboPointBarFrame:SetParent(PlayerFrameBottomManagedFramesContainer)
    nUI_Movers:lockFrame( RogueComboPointBarFrame, true, "nUI_RogueComboPointFrame" ); 		
    
    -- Power Type 64 to investigate
end


-- Shadow Priest Alternate Mana Bar
local function PTM_PriestPBInit()
    -- Can't see where PriestBarFrame appears but will leave it here just in case its needed
    PriestBarFrame:SetParent(PTM_Frame)
    nUI_Movers:lockFrame(PriestBarFrame,true,"nUI_PriestBarFrame")
    PlayerFrameAlternateManaBar:SetParent(PlayerFrameBottomManagedFramesContainer)        
    nUI_Movers:lockFrame( PlayerFrameAlternateManaBar, true, "nUI_PriestAlternateManaBar" ); 	
    -- Power Type 6 : Radiant damage (Purge the Wicked)
end

local function PTM_EvokerEssenceInit()
    PlayerFrameBottomManagedFramesContainer:SetParent(PTM_Frame)
    EssencePlayerFrame:SetParent(PlayerFrameBottomManagedFramesContainer)
    nUI_Movers:lockFrame(EssencePlayerFrame,true,"nUI_EssencePlayerFrame")
end

local function PTM_DeathKnightRuneInit()
    PlayerFrameBottomManagedFramesContainer:SetParent(PTM_Frame)
    RuneFrame:SetParent(PlayerFrameBottomManagedFramesContainer)
    nUI_Movers:lockFrame(RuneFrame,true,"nUI_RuneFrame")
end


local function PTM_Events(self,event,...)

	local arg1,arg2,arg3,arg4,arg5,arg6 = ...;

    local refreshFrame = false
	
	if ( event == "ADDON_LOADED" and arg1 == addonName ) then	
		self.unit = PlayerFrame.unit;		
		
	elseif ( event == "PLAYER_ENTERING_WORLD") then
        refreshFrame = true
		self:UnregisterEvent(event);
        
    elseif ( event == "PLAYER_SPECIALIZATION_CHANGED") then
        spec = GetSpecialization();
        refreshFrame = true  
	end
    
    if not refreshFrame then return end
    
	local emptyVar, class = UnitClass("player");
    local spec = GetSpecialization();
    
    if class == "MONK" then 
        if spec == 3 then 
            PTM_MonkHBInit();
        elseif spec == 1 then 
            PTM_MonkSBInit();
        end
        
    elseif class == "PALADIN" then PTM_PaladinPBInit(); 
    elseif class == "WARLOCK" then PTM_WarlockPBInit(); 
    elseif class == "MAGE" then PTM_MagePBInit(); 
    elseif class == "SHAMAN" then PTM_ShamanTotemsInit();
    elseif class == "DRUID" then PTM_DruidPBInit();
    elseif class == "PRIEST" then PTM_PriestPBInit();
    elseif class == "ROGUE" then PTM_RogueComboInit();
    elseif class =="EVOKER" then PTM_EvokerEssenceInit();
    elseif class =="DEATHKNIGHT" then PTM_DeathKnightRuneInit();
    end

    -- Death Knight Rune Frame is a part of nUI's hud and seems to work fine.
    -- Not as of 10.1 so seeing if I can add it to this.

end

--[[ Register the events we want to watch ]]--
PTM_Frame:SetScript( "OnEvent", PTM_Events );
PTM_Frame:RegisterEvent( "ADDON_LOADED" );
PTM_Frame:RegisterEvent( "PLAYER_ENTERING_WORLD" );
PTM_Frame:RegisterEvent( "PLAYER_SPECIALIZATION_CHANGED")

PTM_Frame:Show()

